import { World, Commands, BlockLocation } from "mojang-minecraft";

World.events.tick.subscribe(handler);


function hasTag(player, tag) {
  let d = World.getDimension("overworld");
  
  try {
    let msg = Commands.run(`tag "${player.name}" list`, d).statusMessage;
    let msgSplited = msg.split(":");
    let playerTags = msgSplited.length > 1 ? msgSplited[1].match(/§a(.*?)§r/)[1].trim().split(",") : [];
    
    return playerTags.find(it => it == tag) ? true : false;
  } catch (e) {}
}


let active = false;

function handler() {
  let players = World.getPlayers();


  for (let i = 0; i < players.length; i++) {
    try{
        
        Commands.run(`execute @a[name="${players[i].name}"] ~~~ function potions`, World.getDimension('overworld'));

        if (hasTag(players[i], "tp_distance") && players[i].isSneaking == true && active == false) {
          Commands.run(`playsound mob.endermen.portal @a[name="${players[i].name}"] ~~~ 4 1 4`, World.getDimension('overworld'));
          Commands.run(`execute @a[name="${players[i].name}"] ~~1~ tp @s ^^^7`, World.getDimension('overworld'));
          active = true;
        }
        
        else if (players[i].isSneaking != true) {
          active = false;
        }

    }catch(e){
    }
  }
}